﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace TPLSamples.Models
{
    public class LoopStopSample : LoopBreakSample
    {
        public override string SampleName
        {
            get { return "Loop Stop Sample"; }
        }

        public override void Run(System.Drawing.Bitmap bmp = null, Action<string> UpdateLog = null)
        {
            Stopwatch s = new Stopwatch();
            s.Start();

            UpdateLog("Running to " + MaxValue);
            var loopResult = Parallel.For(0, MaxValue, (int i, ParallelLoopState loop) =>
            {
                if (i > BreakValue)
                {
                    UpdateLog("Stopping at " + i);
                    loop.Stop();
                    return;
                }
                UpdateLog("Starting at " + i);
                while(!loop.IsStopped)
                {
                    Thread.Sleep(10);
                }
            });
            UpdateLog("IsCompleted == " + loopResult.IsCompleted);
            if (!loopResult.LowestBreakIteration.HasValue)
                UpdateLog("LowestBreakIteration has no value");
            else
                UpdateLog("LowestBreakIteration.Value == " + loopResult.LowestBreakIteration.Value);

            s.Stop();
            RunTime = s.Elapsed;
        }
    }
}
